/// <reference types="node" />
import http from 'http';
import { WebhookReceiver } from '../model/webhookReceiver';
import { WebhookReceiverRequest } from '../model/webhookReceiverRequest';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum WebhookReceiversApiApiKeys {
    tokenAuth = 0
}
export declare class WebhookReceiversApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        tokenAuth: ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: WebhookReceiversApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    webhookReceiversCreate(xAccountToken: string, webhookReceiverRequest: WebhookReceiverRequest, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WebhookReceiver;
    }>;
    webhookReceiversList(xAccountToken: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: Array<WebhookReceiver>;
    }>;
}
